# Linker config file for targeting the Atari 2600.

MEMORY {
   CRAMR:   start=$F000, size=$0400, type=rw, define=yes;
   CRAMW:   start=$F400, size=$0400, type=rw, define=yes;
   ROM:     start=$F800, size=$01FC, type=ro, define=yes, file=%O, fill=yes;
   VECTORS: start=$F9FC, size=$04,   type=ro, define=yes, file=%O, fill=yes;
   TIA:     start=$00,   size=$40,   type=rw, define=yes;
   RAM:     start=$80,   size=$80,   type=rw, define=yes;
   RIOT:    start=$280,  size=$20,   type=rw, define=yes;
}

SEGMENTS {
   RODATA:   load=ROM,     type=ro, align=$100;	
   CODE:     load=ROM,     type=ro, define=yes;
   VECTORS:  load=VECTORS, type=ro;
   ZEROPAGE: load=RAM,     type=zp;
   TIA:      load=TIA,     type=rw, define=yes, optional=yes;
   RIOT:     load=RIOT,    type=rw, define=yes, optional=yes;
}

